/* Program Monitoring Sensor DHT 11
 * Nanobot Workshop
 * https://nanobotworkshop.blogspot.com/2021/02/monitoring-sensor-dht-11-via-iot-google.html
 */

//Library
#include <dht.h>
#include "FirebaseESP8266.h"
#include <ESP8266WiFi.h>

//Pengaturan sensor
#define sensor D5   //Pin D5 --> Output sensor

//inisialisasi variabel sensor
dht DHT;            
float humidity;   //Variabel kelembapan
float suhu;       //Variabel suhu

//Pengaturan Firebase
#define FIREBASE_HOST "Firebase URL"     //Firebase URL
#define FIREBASE_AUTH "Firebase Token"   //Firebase Token
#define WIFI_SSID "WiFi SSID"
#define WIFI_PASSWORD "WiFi password"

FirebaseData firebaseData;
FirebaseJson json;

void setup() {
  Serial.begin(9600);     //Komunikasi serial dengan PC

//WiFi
  WiFi.begin(WIFI_SSID, WIFI_PASSWORD);
  Serial.print("Meghubungkan");
  while (WiFi.status() != WL_CONNECTED) {
    Serial.print(".");
    delay(300);  
  }
  Serial.println();
  Serial.print("Terhubung");
  Serial.println(WiFi.localIP());
  Serial.println();

//Firebase
  Firebase.begin(FIREBASE_HOST, FIREBASE_AUTH);
  Firebase.reconnectWiFi(true);    
}

void loop() {
  DHT.read11(sensor);
  humidity = DHT.humidity;
  suhu = DHT.temperature;
  Serial.println(humidity);

  if (Firebase.setFloat(firebaseData, "/sensor", humidity)){    // "/sensor" disesuaikan dengan nama yg ada di database, ganti humidity dengan suhu untuk mengirimkan data suhu
    Serial.println("PASSED");
//    Serial.println("PATH: " + firebaseData.dataPath());
//    Serial.println("TYPE: " + firebaseData.dataType());
//    Serial.println("ETag: " + firebaseData.ETag());
    Serial.println("-------------------------------------");
    Serial.println();
  }
  else {
    Serial.println("FAILED");
    Serial.println("REASON: " + firebaseData.errorReason());
    Serial.println("--------------------------------");
    Serial.println();
  }   
}
